#include <security/pam_modules.h>

//#define _DEBUG

#define MAX_FILENAME_SIZE 256
#define MAX_LINE_SIZE 256
#define FILE_FORMAT SSL_FILETYPE_PEM
#define MAX_USERNAME_SIZE 32

#define default_ca "/opt/ssl/ca/chain.crt"
#define default_crl "/opt/ssl/crl/"
#define default_keys "/mnt/auth/"

#define SECURETTY_FILE "/etc/x509.securetty"
#define TTY_PREFIX     "/dev/"

#define rfcom_dir "/dev/bluetooth/rfcomm/%i"
#define spool_dir "/var/spool/x509/"
#define bt_path "/"

struct _pam_userdata {
    pam_handle_t *pamh;
    char certname[MAX_FILENAME_SIZE];
};

void _pam_log(int err, const char *format, ...);
char *authenticate(const char *user, pam_handle_t *pamh, const char *cadir, const char *cafile, const char *crldir, const char *crlfile, const char *keydir);
int get_key_password(char *buf, int size, int rwflag, void *userdata);

#ifdef _BLUETOOTH
char *BluetoothInit();
void BluetoothFree(char *tmp_dir);
#endif /* _BLUETOOTH */
